/* Version: MPL 1.1/GPL 2.0/LGPL 2.1
 * 
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 * 
 * The Original Code is Named Anchors.
 * 
 * The Initial Developer of the Original Code is Jeroen Peters. 
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *   Jeroen Peters <jpeters@coldmail.nl>
 * 
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 * 
 * ***** END LICENSE BLOCK ***** */
 
 var author              = "Jeroen Peters";
var contentFlag         = CONTENT | PROFILE_CHROME;
var localeFlag          = LOCALE | PROFILE_CHROME;
var displayName         = "Named anchors";
var error               = null;
var folder              = getFolder("Current User", "chrome");
var name                = "namedanchors";
var version             = "0.3.2";
var jarName             = name + ".jar";
var existsInApplication = File.exists(getFolder(getFolder("chrome"), jarName));
var existsInProfile     = File.exists(getFolder(folder, jarName));

initInstall(displayName, name, version);

// If the extension exists in the application folder or it doesn't exist in the profile folder and the user doesn't want it installed to the profile folder
if(existsInApplication || (!existsInProfile && !confirm("Do you want to install the extension into your profile folder?\n(Cancel will install into the application folder)")))
{
    contentFlag = CONTENT | DELAYED_CHROME;
    localeFlag  = LOCALE  | DELAYED_CHROME;
    folder      = getFolder("chrome");
}

setPackageFolder(folder);
error = addFile(author, version, "chrome/" + jarName, folder, null);

// If adding the JAR file succeeded
if(error == SUCCESS)
{
    folder = getFolder(folder, jarName);

    registerChrome(contentFlag, folder, "content/" + name + "/");
    registerChrome(localeFlag , folder, "locale/en-US/" + name + "/");
    registerChrome(localeFlag , folder, "locale/ca-AD/" + name + "/");
    registerChrome(localeFlag , folder, "locale/da-DK/" + name + "/");
    registerChrome(localeFlag , folder, "locale/de-DE/" + name + "/");
    registerChrome(localeFlag , folder, "locale/es-ES/" + name + "/");
    registerChrome(localeFlag , folder, "locale/fi-FI/" + name + "/");
    registerChrome(localeFlag , folder, "locale/fr-FR/" + name + "/");
    registerChrome(localeFlag , folder, "locale/hu-HU/" + name + "/");
    registerChrome(localeFlag , folder, "locale/it-IT/" + name + "/");
    registerChrome(localeFlag , folder, "locale/nl-NL/" + name + "/");
    registerChrome(localeFlag , folder, "locale/pt-BR/" + name + "/");
    registerChrome(localeFlag , folder, "locale/ru-RU/" + name + "/");
    registerChrome(localeFlag , folder, "locale/tr-TR/" + name + "/");
    registerChrome(localeFlag , folder, "locale/ja-JP/" + name + "/");

    error = performInstall();

    // If the install failed
    if(error != SUCCESS && error != 999)
    {
        if(error == -215)
        {
    	    alert("The installation of the extension failed.\nOne of the files being overwritten is read-only.");
        }
        else if(error == -235)
        {
    	    alert("The installation of the extension failed.\nThere is insufficient disk space.");
        }
        else
        {
    	    alert("The installation of the extension failed.\nThe error code is: " + error);
    	}

    	cancelInstall(error);
    }
}
else
{
	alert("The installation of the extension failed.\n" + error);
	cancelInstall(error);
}
